<?php
/*
Plugin Name: کوتاه کننده لینک اتوماتیک
Plugin URI: http://aft.ir
Description: افزونه قدرتمند کوتاه کننده لینک <a href="http://aft.ir/">ای اف تی دات آی آر</a> ، لینک های  شما را بصورت کاملا خودکار کوتاه می کند و در انتهای هر مطلب نمایش می دهد.<br>لینک کوتاه مطالب شما بهتر در ذهن بازدیدکنندگان وبلاک/وبسایتتان خواهد ماند و در معرفی مطلب به دیگران کمک خواهد کرد.<br> لینکهای کوتاه از فیلتر هرزنامه <a href="http://aft.ir/">ای اف تی دات آی آر</a> عبور کرده و امن بودن لینک را تضمین می کند.<br> با توجه به ایجاد یک بک لینک با ایجاد هر لینک کوتاه استفاده از افزونه نقش بسزایی در افزایش رتبه وبلاک/وبسایت شما خواهد داشت.<br>این افزونه، اولین افزونه از نوع خود بوده که بصورت کاملا فارسی و با سرویس دهنده ایرانی پشتیبانی می شود. امید است مورد استفاده هموطنان گرامی قرار بگیرد. <b><a href="../wp-admin/options-general.php?page=aft_shorturl-settings">تنظیمات افزونه</a><b>

Version: 1.0.0 
Author: ایلیا اسراری
Author URI: http://www.Aft.ir/
*/


define('DEFAULT_API_URL', 'http://aft.ir/index.php?api=1&return_url_text=1&longUrl=%s');


class aft_Short_URL
{
    function api_urls()
    {
        return array(
            array(
                'name' => 'سرور 1',
                'url'  => 'http://aft.ir/index.php?api=1&return_url_text=1&longUrl=%s',
                ),
			array(
                'name' => 'سرور 2 (بزودی)',
                'url'  => 'http://aft.ir/index.php?api=1&return_url_text=1&longUrl=%s',
                ),
            );
    }
	


    /**
     * Create short URL based on post URL
     */
    function create($post_id)
    {	
	 
        if (!$apiURL = get_option('aftShortUrlApiUrl')) {
            $apiURL = DEFAULT_API_URL;
        }

        $post = get_post($post_id);
        $pos = strpos($post->post_name, 'autosave');
        if ($pos !== false) {
            return false;
        }
        $pos = strpos($post->post_name, 'revision');
        if ($pos !== false) {
            return false;
        }

		$permalink = str_replace(array('http://','https://'), '',get_permalink($post_id));
        $apiURL = str_replace('%s', urlencode($permalink), $apiURL);

        $result = false;

        if (ini_get('allow_url_fopen')) {
            if ($handle = @fopen($apiURL, 'r')) {
                $result = fread($handle, 4096);
                fclose($handle);
            }
        } elseif (function_exists('curl_init')) {
            $ch = curl_init($apiURL);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
            $result = @curl_exec($ch);
            curl_close($ch);
        }

        if ($result !== false) {
            delete_post_meta($post_id, 'aftShortURL');
            $res = add_post_meta($post_id, 'aftShortURL', $result, true);
            return true;
        }
    }

    /**
     * Option list (default settings)
     */
    function options()
    {
        return array(
           'ApiUrl'         => DEFAULT_API_URL,
           'Display'        => 'Y',
           'TwitterLink'    => 'Y',
           );
    }

    /**
     * Plugin settings
     *
     */
    function settings()
    {
        $apiUrls = $this->api_urls();
        $options = $this->options();
        $opt = array();

        if (!empty($_POST)) {
            foreach ($options AS $key => $val)
            {
                if (!isset($_POST[$key])) {
                    continue;
                }
                update_option('aftShortUrl' . $key, $_POST[$key]);
            }
        }
        foreach ($options AS $key => $val)
        {
            $opt[$key] = get_option('aftShortUrl' . $key);
        }
        include '../wp-content/plugins/aft-shortener/template/settings.tpl.php';
    }

    /**
     *
     */
    function admin_menu()
    {
        add_options_page('aft Short URL', 'کوتاه کننده لینک', 10, 'aft_shorturl-settings', array(&$this, 'settings'));
    }

    /**
     * Display the short URL
     */
    function display($content)
    {

        global $post;

        if ($post->ID <= 0) {
            return $content;
        }

        $options = $this->options();

        foreach ($options AS $key => $val)
        {
            $opt[$key] = get_option('aftShortUrl' . $key);
        }

        $shortUrl = get_post_meta($post->ID, 'aftShortURL', true);

        if (empty($shortUrl)) {
            return $content;
        }

        $shortUrlEncoded = urlencode($shortUrl);

        ob_start();
        include './wp-content/plugins/aft-shortener/template/public.tpl.php';
        $content .= ob_get_contents();
        ob_end_clean();

        return $content;
    }
}

$aftobj = new aft_Short_URL;

if (is_admin()) {
    add_action('publish_post', array(&$aftobj, 'create'));
    add_action('admin_menu', array(&$aftobj, 'admin_menu'));
} else {
    add_filter('the_content', array(&$aftobj, 'display'));
}